/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the ExtractionActionAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ExtractionActionAllOf{}

// ExtractionActionAllOf struct for ExtractionActionAllOf
type ExtractionActionAllOf struct {
	Storage *string `json:"storage,omitempty"`
	// $request_id
	RequestId *string `json:"request_id,omitempty"`
	// $type . Type of automated action.
	Type *string `json:"type,omitempty"`
}

// NewExtractionActionAllOf instantiates a new ExtractionActionAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewExtractionActionAllOf() *ExtractionActionAllOf {
	this := ExtractionActionAllOf{}
	return &this
}

// NewExtractionActionAllOfWithDefaults instantiates a new ExtractionActionAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewExtractionActionAllOfWithDefaults() *ExtractionActionAllOf {
	this := ExtractionActionAllOf{}
	return &this
}

// GetStorage returns the Storage field value if set, zero value otherwise.
func (o *ExtractionActionAllOf) GetStorage() string {
	if o == nil || IsNil(o.Storage) {
		var ret string
		return ret
	}
	return *o.Storage
}

// GetStorageOk returns a tuple with the Storage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionActionAllOf) GetStorageOk() (*string, bool) {
	if o == nil || IsNil(o.Storage) {
		return nil, false
	}
	return o.Storage, true
}

// HasStorage returns a boolean if a field has been set.
func (o *ExtractionActionAllOf) HasStorage() bool {
	if o != nil && !IsNil(o.Storage) {
		return true
	}

	return false
}

// SetStorage gets a reference to the given string and assigns it to the Storage field.
func (o *ExtractionActionAllOf) SetStorage(v string) {
	o.Storage = &v
}

// GetRequestId returns the RequestId field value if set, zero value otherwise.
func (o *ExtractionActionAllOf) GetRequestId() string {
	if o == nil || IsNil(o.RequestId) {
		var ret string
		return ret
	}
	return *o.RequestId
}

// GetRequestIdOk returns a tuple with the RequestId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionActionAllOf) GetRequestIdOk() (*string, bool) {
	if o == nil || IsNil(o.RequestId) {
		return nil, false
	}
	return o.RequestId, true
}

// HasRequestId returns a boolean if a field has been set.
func (o *ExtractionActionAllOf) HasRequestId() bool {
	if o != nil && !IsNil(o.RequestId) {
		return true
	}

	return false
}

// SetRequestId gets a reference to the given string and assigns it to the RequestId field.
func (o *ExtractionActionAllOf) SetRequestId(v string) {
	o.RequestId = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *ExtractionActionAllOf) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionActionAllOf) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *ExtractionActionAllOf) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *ExtractionActionAllOf) SetType(v string) {
	o.Type = &v
}

func (o ExtractionActionAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ExtractionActionAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Storage) {
		toSerialize["storage"] = o.Storage
	}
	if !IsNil(o.RequestId) {
		toSerialize["request_id"] = o.RequestId
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	return toSerialize, nil
}

type NullableExtractionActionAllOf struct {
	value *ExtractionActionAllOf
	isSet bool
}

func (v NullableExtractionActionAllOf) Get() *ExtractionActionAllOf {
	return v.value
}

func (v *NullableExtractionActionAllOf) Set(val *ExtractionActionAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableExtractionActionAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableExtractionActionAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableExtractionActionAllOf(val *ExtractionActionAllOf) *NullableExtractionActionAllOf {
	return &NullableExtractionActionAllOf{value: val, isSet: true}
}

func (v NullableExtractionActionAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableExtractionActionAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
